' 
' SIDcog TrainSound 
' 

CON _clkmode = xtal1 + pll16x
    _xinfreq = 5_000_000    
    freqAdjust  = 0.97                       ' Adjust the relative frequency of both 1 and 2 
    freq1       = trunc(8000.0*freqAdjust)   ' Whistle frecuency 1                              
    freq2       = trunc(12050.0*freqAdjust)  ' Whistle frecuency 2
    
    whistleWait = 511                        ' Wait between whistles, try different values, 255, 1023, 2047, 4097, 8191
    updateRate  = 90                         ' Tuff tuff speed
    
OBJ
  SID : "SIDCog"

PUB Main | i, whistle, frame

  SID.start(10,11)                        'Start the emulated SID and output sound on pin 10 and 11 
  SID.setFilterType(true,true,false)      'Enable lowpass filter
  SID.setFilterMask(true,false,false)     'Enable filter on the bass channel (channel1)
  SID.setResonance(15)                    'Enable lowpass filter  
  SID.setCutoff(160)                      
  SID.setVolume(15)                       'Set volume to max

  repeat
    waitcnt(cnt+(clkfreq/updateRate))
    frame++

    ' This is for controlling the whistle
    if (frame&whistleWait) == 120 or (frame&whistleWait) == 180 
      whistle := true
    if (frame&whistleWait) == 160  or (frame&whistleWait) == 240
      whistle := false


    'Tuff tuff sound
    if (frame&15)==7 and not whistle
      SID.play(0,24000+((?i)&511),SID#NOISE,0,5,6,9)
    if (frame&15) == 12 and not whistle 
      SID.noteOff(0)

    'Whistle sound
    if whistle
      SID.setResonance(15)
      SID.setFilterMask(true,true,true) 
      SID.setFilterType(false,false,true)
      SID.setCutoff(120)
      SID.play(0,20_000+((?i)&511),SID#NOISE,3,3,2,4)
      SID.play(1,freq1,SID#TRIANGLE,1,2,4,12) 
      SID.play(2,freq2,SID#TRIANGLE,1,2,4,12) 
    else
      SID.setResonance(10)
      SID.setFilterMask(true,false,false)
      SID.setFilterType(true,true,false)
      SID.setCutoff(160)
      SID.noteOff(1)
      SID.noteOff(2)     
